import {DateTime} from "../../../ChillMainBundle/Resources/public/types";

export type StoredObjectStatus = "ready"|"failure"|"pending";

export interface StoredObject {
  id: number,

  /**
   * filename of the object in the object storage
   */
  filename: string,
  creationDate: DateTime,
  datas: object,
  iv: number[],
  keyInfos: object,
  title: string,
  type: string,
  uuid: string,
  status: StoredObjectStatus,
    _links?: {
      dav_link?: {
          href: string
          expiration: number
      },
    }
}

export interface StoredObjectCreated {
    status: "stored_object_created",
    filename: string,
    iv: Uint8Array,
    keyInfos: object,
    type: string,
}

export interface StoredObjectStatusChange {
  id: number,
  filename: string,
  status: StoredObjectStatus,
  type: string,
}

/**
 * Function executed by the WopiEditButton component.
 */
export type WopiEditButtonExecutableBeforeLeaveFunction = {
  (): Promise<void>
}

/**
 * Object containing information for performering a POST request to a swift object store
 */
export interface PostStoreObjectSignature {
    method: "POST",
    max_file_size: number,
    max_file_count: 1,
    expires: number,
    submit_delay: 180,
    redirect: string,
    prefix: string,
    url: string,
    signature: string,
}

